#include "httpUploader.h"
#include <iostream>
#include <cassert>

using namespace std;


HTTPUploader::HTTPUploader():
curlHandle(curl_easy_init()) {}

HTTPUploader::~HTTPUploader() {
	curl_easy_cleanup(curlHandle);
}

bool HTTPUploader::uploadFile(const char *theurl,const char *filename) {

	/* specify target URL */
	CURLcode curlErr = curl_easy_setopt(curlHandle, CURLOPT_URL, theurl);
	if (curlErr != CURLE_OK) {
		cerr << "got curl error on setopt CURLOPT_URL " << curlErr << endl;
		return false;
	}
    
 	struct curl_httppost *post=NULL;  
 	struct curl_httppost *last=NULL;  
 
   	curl_formadd(&post, &last,   CURLFORM_COPYNAME, "upload", CURLFORM_COPYCONTENTS, "true", CURLFORM_END);
	
 	curl_formadd(&post, &last,
                 CURLFORM_COPYNAME, "bytes",
                 CURLFORM_FILE, filename,
                 CURLFORM_CONTENTTYPE, "image/jpeg",
                 CURLFORM_END);

 	/* Set the form info */  
 	curlErr = curl_easy_setopt(curlHandle, CURLOPT_HTTPPOST, post);
	if (curlErr != CURLE_OK) {
		cerr << "got curl error on setopt HTTPPOST " << curlErr << endl;
		return false;
	}
	
	/* perform transfer */
	printf("Perform transfer!\n");
	curlErr = curl_easy_perform(curlHandle);
	if (curlErr != CURLE_OK) {
		cerr << "got curl error on perform " << curlErr << endl;
		return false;
	}

	/* free the post data again */  
	curl_formfree(post);
    
	return true;
}


